//---------------------------------------------------------------------------
#ifndef plotH
#define plotH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include "graph.h"
#include "rtklib.h"
#include <ComCtrls.hpp>

#define POSMAX      100000

//---------------------------------------------------------------------------
class TSolPlot : public TForm
{
__published:
	TPanel *Panel2;
	TLabel *Message2;
	TPanel *Panel1;
	TComboBox *Select;
	TPanel *Panel11;
	TButton *BtnClose;
	TPanel *Panel22;
	TPanel *Panel21;
	TLabel *Message1;
	TComboBox *PlotType;
	TPaintBox *Disp;
	TButton *BtnOption;
	TScrollBar *TimeScroll;
	TComboBox *QFlag;
	TButton *BtnRead;
	TOpenDialog *OpenDialog;
	TPaintBox *View;
	void __fastcall BtnCloseClick(TObject *Sender);
	void __fastcall SelectChange(TObject *Sender);
	void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall PlotTypeChange(TObject *Sender);
	void __fastcall DispMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall DispMouseLeave(TObject *Sender);
	void __fastcall DispMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall DispMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall BtnOptionClick(TObject *Sender);
	void __fastcall TimeScrollChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall QFlagChange(TObject *Sender);
	void __fastcall DispPaint(TObject *Sender);
private:
	int Drag,Xn,Yn,NPos[3];
	AnsiString Files[3];
	gtime_t Time[3][POSMAX];
	double X0,Y0,Xc,Yc,Xs,Ys,OPos[3],RPos[3][NSOL],Pos[3][POSMAX][NSOL];
	TGraph *GraphT,*GraphG[3];
	void __fastcall Refresh(void);
	void __fastcall DrawGraphT(int level);
	void __fastcall DrawGraphG(int level);
	void __fastcall UpdateSelect(void);
	void __fastcall UpdateTime(void);
	void __fastcall UpdateInfo(void);
	void __fastcall UpdatePoint(int x, int y);
	void __fastcall UpdateOrigin(void);
	void __fastcall UpdateColor(void);
	void __fastcall UpdateLim(void);
	void __fastcall SolToXyz(const double pos[][NSOL], int n, double x[],
	    double y[], double z[]);
	double __fastcall SolToVel(const gtime_t *time, const double *pos,
		double &dir);
	void __fastcall DrawArrow(const gtime_t *t, const double *x,
		const double *y, int n);
	void __fastcall CalcStats(const double *x, int n, double ref, double &ave,
		double &std, double &rms);
	AnsiString __fastcall TimeStr(gtime_t time, int n);
public:
	static TColor CColor[4];
	static int PlotTypeD,QFlagD,PlotStyle,MarkSize,Origin,TimeLabel;
	static int AutoScale,ShowArrow,ShowStats;
	static double YRange,OOPos[3];
	__fastcall TSolPlot(TComponent* Owner);
	void __fastcall Read(AnsiString file);
};
//---------------------------------------------------------------------------
extern PACKAGE TSolPlot *SolPlot;
//---------------------------------------------------------------------------
#endif
